.nolist			; Hit F6 to assemble and run this program
include \masm32\include\masm32rt.inc

WinMain	PROTO:DWORD,:DWORD,:DWORD,:DWORD
ttsEnd=0
ToolTips MACRO hTTC, lpText	; must be placed at the end of WM_CREATE handler
LOCAL tts
  ifidni <hTTC>, <end>
	ttsEnd=-1
	.endif
	pop ebx
	pop edi
	pop esi
  else
	tts=0
	ifndef MbTIS
		tts=1
		; ttsEnd=TOOLINFO		; offset for control handles
		.DATA?
	hMbTIS	dd ?
	MbTIS	TOOLINFO <?>
	hMbTISc	dd 20 dup(?)
		.DATA
	MbIcc	INITCOMMONCONTROLSEX <sizeof INITCOMMONCONTROLSEX, ICC_TREEVIEW_CLASSES>	; [url=http://msdn.microsoft.com/en-us/library/bb775507%28v=VS.85%29.aspx]MSDN[/url]
		.CODE
	elseifidni <hTTC>, <start>
		tts=1
	elseifb <lpText>
		tts=1
	endif
	if tts
		  .if 1
			push esi
			push edi
			push ebx
			invoke InitCommonControlsEx, offset MbIcc
			xor ebx, ebx

			mov esi, offset MbTIS
			if (opattr hTTC) eq 36
				MbToolFlags = hTTC
			elseifndef MbToolFlags		; 
				MbToolFlags = TTS_NOPREFIX ;or TTS_ALWAYSTIP
			endif
			ifndef MbToolExS
				MbToolExS = WS_EX_TOPMOST		; [url=http://msdn.microsoft.com/en-us/library/bb760252%28v=vs.85%29.aspx]MSDN[/url]
			endif
			MbToolExS = WS_EX_TOPMOST	; override args for
			MbToolFlags = TTS_BALLOON	; testing the API bug
			invoke SetLastError, 1
			invoke CreateWindowEx, MbToolExS, chr$("tooltips_class32"), ebx,
			MbToolFlags, ebx, ebx, ebx, ebx, hWnd, ebx, hInstance, ebx
			mov [esi-4], eax		; store handle in hMbTIS
			xchg eax, edi
;			mov eax, LastError$()
;			deb 1, "Create TT", edi, $eax
		.data?
			bufferx	db 1024 dup(?)		; Stringtable ID 01 is "Enter text here"
		.code
			pushad
			int 3
			nop
			invoke LoadString, hInstance, 3, offset bufferx, 1000	; size too small
			mov esi, offset bufferx
			mov edi, eax
			mov eax, LastError$()
			MsgBox 0, eax, "LoadString error:", MB_OK
;			LoadString bugs:
;			edi		0	; retval
;			$eax	Un thread che attualmente non rappresenta un client ha tentato di operare su un token di rappresentazione di client.
			popad

;invoke LoadString, hInstance, 01, offset bufferx, -3	; negative size
;LoadString bugs:
;edi             -4  (=-4 characters successful copied, congrats...)
;$eax            Operazione completata.
;$esi            (empty string)

;invoke LoadString, hInstance, 01, offset bufferx, 5	; size too small
;LoadString bugs:
;edi             4
;$eax            Operazione completata.
;$esi            Ente

;invoke LoadString, 0, 01, offset bufferx, 5	; zero hInstance, size too small
;LoadString bugs:
;edi             4
;$eax            Operazione completata.
;$esi            Ente

;invoke LoadString, 0, -99, offset bufferx, 5	; zero hInstance, size too small, wrong ID
;LoadString bugs:
;edi             0
;$eax            Impossibile trovare il nome di risorsa specificato nel file immagine.
;$esi

			m2m [esi.TOOLINFO.cbSize], sizeof TOOLINFO
			m2m [esi.TOOLINFO.uFlags], TTF_SUBCLASS or TTF_IDISHWND	; m2m is shorter
			m2m [esi.TOOLINFO.hWnd], hWnd
			m2m [esi.TOOLINFO.hInst], hInstance
	endif
	ifnb <lpText>
		if ttsEnd lt 0
			mov eax, hTTC
			push esi
			mov esi, offset MbTIS
			mov [esi.TOOLINFO.uId], eax
			mov [esi.TOOLINFO.lpszText], lpText
			ifidn <lpText>, <( EdX)>	; wRes$()
				invoke SendMessage, [esi-4], TTM_ADDTOOLW, 0, esi
			else
				invoke SendMessage, [esi-4], TTM_ADDTOOLA, 0, esi
			endif
			pop esi
		elseifdif <lpText>, <0>
			mov eax, hTTC
			mov [esi.TOOLINFO.uId], eax
			mov [esi.TOOLINFO.lpszText], lpText
			ifidn <lpText>, <( EdX)>	; wRes$()
				invoke SendMessage, edi, TTM_ADDTOOLW, ebx, esi
			else
				invoke SendMessage, edi, TTM_ADDTOOLA, ebx, esi
			endif
		endif
	endif
  endif
ENDM

; equates and constants
sm	equ invoke SendMessage, 	; for faster typing ;-)
IdEscape	equ VK_ESCAPE		; press Esc to quit your window
IdMenuNew	equ 1000			; ID menu item New
IdMenuSave	equ 1001			; ID menu item Save
IdMenuCopy	equ 1100			; ID menu item Copy
IdListbox	equ 2000
IdButton1	equ 2001
IdButton2	equ 2002
IdStatic	equ 2003
AppX	equ 50			; window positioning
AppY	equ 50
AppWidth	equ 900
AppHeight	equ 700
ButtonWidth	equ 72			; button sizes in pixels
ButtonHeight	equ 24

.data
ClassAppWin	db "MyClass", 0
ClassButton	db "button", 0
ClassListbox	db "listbox", 0
ClassStatic	db "static", 0
txButton1	db "PushMe", 0
txButton2	db "Say Hi", 0
txStatic	db "Welcome to", 13, 10	; no 0 - text continues with AppName ;-)
AppName	db "Tiny Win App", 0
MyAccels	ACCEL <FCONTROL or FVIRTKEY, VK_S, IdMenuSave>
LastAccel	ACCEL <FVIRTKEY, VK_ESCAPE, IdEscape>

.data?
hInstance	HINSTANCE ?
CommandLine	LPSTR ?
hButton1	HWND ?
hButton2	HWND ?
hStatic	HWND ?
hListbox	HWND ?
hMenu	HWND ?
hM1	HWND ?
hM2	HWND ?
hButFnt	HWND ?
haccl	HWND ?

.code
start:
	invoke GetModuleHandle, NULL
	mov hInstance, eax
	invoke GetCommandLine
	invoke WinMain, hInstance, NULL, eax, SW_SHOWDEFAULT
	invoke ExitProcess, eax

WinMain proc hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG
LOCAL hwnd:HWND
	call ClearLocVars	; set all local variables to zero
	mov wc.cbSize, SIZEOF WNDCLASSEX
	mov wc.style, CS_HREDRAW or CS_VREDRAW
	mov wc.lpfnWndProc, offset WndProc
;	 mov wc.cbClsExtra, NULL		not needed, ClearLocVars
;	 mov wc.cbWndExtra, NULL		has cleared them already
	push hInst
	pop wc.hInstance
	mov wc.hbrBackground, COLOR_BTNFACE+1
	mov wc.lpszClassName, offset ClassAppWin
	invoke LoadIcon, hInst, IDI_APPLICATION
	mov wc.hIcon, eax
	mov wc.hIconSm, eax
	invoke LoadCursor, NULL, IDC_ARROW
	mov wc.hCursor, eax
	invoke RegisterClassEx, addr wc
	invoke CreateWindowEx, WS_EX_CLIENTEDGE,
		addr ClassAppWin, addr AppName,
		WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN,
		AppX, AppY, AppWidth, AppHeight,
		NULL, NULL, hInst, NULL
	mov hwnd, eax
	invoke ShowWindow, hwnd, SW_SHOWNORMAL
	.Repeat
		invoke GetMessage, addr msg, NULL, 0, 0
		.break .if eax==0
		invoke TranslateAccelerator, hwnd, haccl, addr msg
		.if eax==0		; not an accelerator
			invoke TranslateMessage, addr msg
			invoke DispatchMessage, addr msg
		.endif
	.Until 0
	mov eax, msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
LOCAL rc:RECT
	SWITCH uMsg
	CASE WM_DESTROY
		invoke PostQuitMessage, NULL

	CASE WM_CREATE
		; -------------------- create keyboard shortcuts -------------------- 

		mov eax, 1+(dword ptr LastAccel-dword ptr MyAccels)/(SIZEOF ACCEL)
		invoke CreateAcceleratorTable, addr MyAccels, eax	; eax needed because of a [url=http://www.masm32.com/board/index.php?topic=10435.msg76444#msg76444]MASM Version 9.0 bug[/url]
		mov haccl, eax

		; -------------------- create menus and sub-menus -------------------- 
		mov hMenu, rv(CreateMenu)				; create the main menu
		mov hM1, rv(CreateMenu)				; plus two
		mov hM2, rv(CreateMenu)				; sub menus
		invoke AppendMenu,hMenu, MF_POPUP, hM1,chr$("&File")
		invoke AppendMenu, hM1, MF_STRING, IdMenuNew, chr$("&New",9,"Ctrl+N")
		invoke AppendMenu, hM1, MF_STRING, IdMenuSave, chr$("&Save",9,"Ctrl+S")
		invoke AppendMenu,hMenu, MF_POPUP, hM2,chr$("&Edit")
		invoke AppendMenu, hM2, MF_STRING, IdMenuCopy, chr$("&Copy",9,"Ctrl+C")
		invoke SetMenu, hWnd, hMenu			; attach menu to main window

		; -------------------- create controls: buttons, listbox, static ---------- 
		invoke GetStockObject, ANSI_VAR_FONT	; get a cute little font for the controls
		mov hButFnt, eax
		invoke CreateWindowEx, WS_EX_CLIENTEDGE, addr ClassListbox, NULL, 
			WS_CHILD or WS_VISIBLE or WS_BORDER	or WS_VSCROLL or \	;LBS_SORT or
			LBS_NOINTEGRALHEIGHT or LBS_USETABSTOPS,
			0, 0, 0, 0,
			hWnd, IdListbox, hInstance, NULL
		mov hListbox, eax						; we have created a listbox
		invoke GetStockObject, ANSI_FIXED_FONT	; get a cute little font for the controls
		sm hListbox, WM_SETFONT, eax, 1	; you may choose the small font here
		invoke CreateWindowEx, NULL, addr ClassButton, addr txButton1, 
			WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON, 0, 0, 0, 0,
			hWnd, IdButton1, hInstance, NULL
		mov hButton1, eax						; upper button created
		sm eax, WM_SETFONT, hButFnt, 1	; give it the small font
		invoke CreateWindowEx, NULL, addr ClassButton, addr txButton2, 
			WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON, 0, 0, 0, 0,
			hWnd, IdButton2, hInstance, NULL
		mov hButton2, eax						; lower button created
		sm eax, WM_SETFONT, hButFnt, 1	; give it the small font
		mov edx, rc.bottom 					; area below the two buttons
		sub edx, ButtonHeight*2+15				; will be used for a static control
		invoke CreateWindowEx, NULL, addr ClassStatic, addr txStatic,
			WS_CHILD or WS_VISIBLE or ES_LEFT, 0, 0, 0, 0,
			hWnd, IdStatic, hInstance, NULL
		mov hStatic, eax						; static window under buttons created
		sm eax, WM_SETFONT, hButFnt, 1	; give it the small font
		call MyListBox
		ToolTips TTS_BALLOON
		ToolTips hButton1, chr$("A tooltip")
		ToolTips end
		invoke SetFocus, hButton1				; give the focus to PushMe

	CASE WM_COMMAND					; react here to menus and controls
		movzx eax, word ptr wParam			; the Ids are in the lowword of wParam
		switch eax
		case IdMenuNew						; feel free to call your own stuff here...
			sm hStatic, WM_SETTEXT, 0, chr$("You clicked New")
		case IdMenuSave
			sm hStatic, WM_SETTEXT, 0,
			chr$("You either clicked Save, or you pressed Control S")
		case IdMenuCopy
			sm hStatic, WM_SETTEXT, 0, chr$("You clicked Copy")
		case IdButton1
			call MyListBox
		case IdButton2
			MsgBox 0, "No Credits", "Hi", MB_OK
		case IdListbox
			sm hStatic, WM_SETTEXT, 0, chr$("Type some text")
		case IdEscape
;			MsgBox 0, chr$("Sure to exit?"), addr AppName, MB_YESNO
;			.if eax==IDYES
				sm hWnd, WM_CLOSE, 0, 0	; Escape: exit without asking!
;			.endif
		default
			; MsgBox 0, chr$("Other control"), addr AppName, MB_OK
		endsw

	CASE WM_SIZE			; resize controls
		invoke GetClientRect, hWnd, addr rc
		push esi
		push ebx
		mov esi, rc.right
		sub esi, ButtonWidth	; editbox = window width minus button width
		mov ebx, rc.bottom
		sub ebx, 6
		invoke MoveWindow, hListbox, 3, 3, esi, ebx, 1
		add esi, 5				; buttons 5 pixels right of editbox
		mov ebx, rc.right
		sub ebx, esi
		sub ebx, 3
		invoke MoveWindow, hButton1, esi, 5, ebx, ButtonHeight, 1
		invoke MoveWindow, hButton2, esi, 8+ButtonHeight, ebx, ButtonHeight, 1
		mov edx, rc.bottom
		sub edx, ButtonHeight*2+15
		invoke MoveWindow, hStatic, esi, 11+ButtonHeight*2, ebx, edx, 1
		pop ebx
		pop esi

	DEFAULT
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		ret
	ENDSW
	xor eax, eax
	ret
WndProc endp

MyListBox proc uses esi edi	; requires the [url=http://www.masm32.com/board/index.php?topic=12460]MasmBasic library[/url]
	ret
MyListBox endp
; [url=+1]back to wm_command[/url]

ClearLocVars proc	; put "call ClearLocals" as first instruction after LOCALS - eax unchanged on exit
  push eax		; do not use with uses esi etc - push them manually behind the call!
  lea eax, [esp+8]		; pushed eax and ret address
  mov esp, ebp		; base page of calling procedure
  align 4		; 74 instead of 123 cycles on Celeron M, no effect on P4
@@:
  push 0		; 120 bytes: 196 cycles on P4
  cmp esp, eax		; rep stosd??
  ja @B
  sub esp, 8		; 19 bytes with align 4
  pop eax
  ret
ClearLocVars endp
end start

Resources must be put below the end label; when pressing F6, content between the two Rsrc lines will be written to [filename].rc
Any kind of resources are allowed here; use strings with e.g. Print Res$(101) or wPrint #1, wRes$(102) (w=wide, Unicode)
Note that in order to avoid bloated sections, strings should be incremented by 1, and start with indices that can be divided
by 16, as shown below (400/16=25, 800/16=50 etc). Note opt_icon will be ignored - what counts is the icon specified in the
resource file. You may delete these five lines once you don't need them any more.
